;--------------------------------------------------------
; File Created by ZCCC : free open source ANSI-C Compiler
; Version 3.6.0 #Apr 15 2020 (MSVC)
;--------------------------------------------------------
; MC8X port for the RISC core
;--------------------------------------------------------
;	.file	"EEPROM_WRITE_READ.C"
	list	p=QT8S736
	radix dec
	include "QT8S736.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_System_Init
	extern	_Clr_RAM_00H_7FH
	extern	_INDF0bits
	extern	_FSR0bits
	extern	_INDF1bits
	extern	_FSR1bits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_OPTIONbits
	extern	_OSCMbits
	extern	_WDTCbits
	extern	_IOBICRbits
	extern	_INDF2bits
	extern	_HBUFbits
	extern	_PDBbits
	extern	_INTCR0bits
	extern	_INTF0bits
	extern	_INTCR1bits
	extern	_INTF1bits
	extern	_IOAbits
	extern	_OEAbits
	extern	_PUAbits
	extern	_ANSAbits
	extern	_IOBbits
	extern	_OEBbits
	extern	_PUBbits
	extern	_ANSBbits
	extern	_IOCbits
	extern	_OECbits
	extern	_PUCbits
	extern	_ANSCbits
	extern	_IOIDSbits
	extern	_I2CADRbits
	extern	_I2CCONbits
	extern	_I2CBUFbits
	extern	_PWM0CRbits
	extern	_PWM0Dbits
	extern	_TXCRbits
	extern	_TXREGbits
	extern	_RXCRbits
	extern	_RXREGbits
	extern	_BRGDHbits
	extern	_BRGDLbits
	extern	_ADCON0bits
	extern	_ADCON1bits
	extern	_ADCON2bits
	extern	_T1CRbits
	extern	_TC1CLbits
	extern	_TC1CHbits
	extern	_T0CRbits
	extern	_TC0CLbits
	extern	_TC0CHbits
	extern	_PWM1DEADbits
	extern	_PWM1Sbits
	extern	_PWM1CRbits
	extern	_PWM1DLbits
	extern	_PWM1DHbits
	extern	_EECON1bits
	extern	_EECON2bits
	extern	_VREFCALbits
	extern	_IRCCALbits
	extern	_INDF0
	extern	_FSR0
	extern	_INDF1
	extern	_FSR1
	extern	_PCL
	extern	_STATUS
	extern	_OPTION
	extern	_OSCM
	extern	_WDTC
	extern	_IOBICR
	extern	_INDF2
	extern	_HBUF
	extern	_PDB
	extern	_INTCR0
	extern	_INTF0
	extern	_INTCR1
	extern	_INTF1
	extern	_IOA
	extern	_OEA
	extern	_PUA
	extern	_ANSA
	extern	_IOB
	extern	_OEB
	extern	_PUB
	extern	_ANSB
	extern	_IOC
	extern	_OEC
	extern	_PUC
	extern	_ANSC
	extern	_IOIDS
	extern	_I2CADR
	extern	_I2CCON
	extern	_I2CBUF
	extern	_PWM0CR
	extern	_PWM0D
	extern	_TXCR
	extern	_TXREG
	extern	_RXCR
	extern	_RXREG
	extern	_BRGDH
	extern	_BRGDL
	extern	_ADCON0
	extern	_ADCON1
	extern	_ADL
	extern	_ADH
	extern	_ADCON2
	extern	_T1CR
	extern	_TC1CL
	extern	_TC1CH
	extern	_T0CR
	extern	_TC0CL
	extern	_TC0CH
	extern	_PWM1DEAD
	extern	_PWM1S
	extern	_PWM1CR
	extern	_PWM1DL
	extern	_PWM1DH
	extern	_EECON1
	extern	_EECON2
	extern	_VREFCAL
	extern	_IRCCAL

	extern STK11
	extern STK10
	extern STK09
	extern STK08
	extern STK07
	extern STK06
	extern STK05
	extern STK04
	extern STK03
	extern STK02
	extern STK01
	extern STK00
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_Interrupt_INIT
	global	_EEPROM_Read_Byte
	global	_EEPROM_Write_Byte
	global	_EEPROM_Read
	global	_EEPROM_Write_Read

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'EEPROM_Write_Read'
;@EEPROM_Write_Read System_Init               Allocated to registers ;size:2
;@EEPROM_Write_Read Clr_RAM_00H_7FH           Allocated to registers ;size:2
;@EEPROM_Write_Read Interrupt_INIT            Allocated to registers ;size:2
;@EEPROM_Write_Read EEPROM_Write_Byte         Allocated to registers ;size:2
;@EEPROM_Write_Read EEPROM_Read               Allocated to registers ;size:2
;@EEPROM_Write_Read EEPROM_Read_Byte          Allocated to registers ;size:2
;@EEPROM_Write_Read INDF0bits                 Allocated to registers ;size:1
;@EEPROM_Write_Read FSR0bits                  Allocated to registers ;size:1
;@EEPROM_Write_Read INDF1bits                 Allocated to registers ;size:1
;@EEPROM_Write_Read FSR1bits                  Allocated to registers ;size:1
;@EEPROM_Write_Read PCLbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read STATUSbits                Allocated to registers ;size:1
;@EEPROM_Write_Read OPTIONbits                Allocated to registers ;size:1
;@EEPROM_Write_Read OSCMbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read WDTCbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read IOBICRbits                Allocated to registers ;size:1
;@EEPROM_Write_Read INDF2bits                 Allocated to registers ;size:1
;@EEPROM_Write_Read HBUFbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read PDBbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read INTCR0bits                Allocated to registers ;size:1
;@EEPROM_Write_Read INTF0bits                 Allocated to registers ;size:1
;@EEPROM_Write_Read INTCR1bits                Allocated to registers ;size:1
;@EEPROM_Write_Read INTF1bits                 Allocated to registers ;size:1
;@EEPROM_Write_Read IOAbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read OEAbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read PUAbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read ANSAbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read IOBbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read OEBbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read PUBbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read ANSBbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read IOCbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read OECbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read PUCbits                   Allocated to registers ;size:1
;@EEPROM_Write_Read ANSCbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read IOIDSbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read I2CADRbits                Allocated to registers ;size:1
;@EEPROM_Write_Read I2CCONbits                Allocated to registers ;size:1
;@EEPROM_Write_Read I2CBUFbits                Allocated to registers ;size:1
;@EEPROM_Write_Read PWM0CRbits                Allocated to registers ;size:1
;@EEPROM_Write_Read PWM0Dbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read TXCRbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read TXREGbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read RXCRbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read RXREGbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read BRGDHbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read BRGDLbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read ADCON0bits                Allocated to registers ;size:1
;@EEPROM_Write_Read ADCON1bits                Allocated to registers ;size:1
;@EEPROM_Write_Read ADCON2bits                Allocated to registers ;size:1
;@EEPROM_Write_Read T1CRbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read TC1CLbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read TC1CHbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read T0CRbits                  Allocated to registers ;size:1
;@EEPROM_Write_Read TC0CLbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read TC0CHbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1DEADbits              Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1Sbits                 Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1CRbits                Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1DLbits                Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1DHbits                Allocated to registers ;size:1
;@EEPROM_Write_Read EECON1bits                Allocated to registers ;size:1
;@EEPROM_Write_Read EECON2bits                Allocated to registers ;size:1
;@EEPROM_Write_Read VREFCALbits               Allocated to registers ;size:1
;@EEPROM_Write_Read IRCCALbits                Allocated to registers ;size:1
;@EEPROM_Write_Read INDF0                     Allocated to registers ;size:1
;@EEPROM_Write_Read FSR0                      Allocated to registers ;size:1
;@EEPROM_Write_Read INDF1                     Allocated to registers ;size:1
;@EEPROM_Write_Read FSR1                      Allocated to registers ;size:1
;@EEPROM_Write_Read PCL                       Allocated to registers ;size:1
;@EEPROM_Write_Read STATUS                    Allocated to registers ;size:1
;@EEPROM_Write_Read OPTION                    Allocated to registers ;size:1
;@EEPROM_Write_Read OSCM                      Allocated to registers ;size:1
;@EEPROM_Write_Read WDTC                      Allocated to registers ;size:1
;@EEPROM_Write_Read IOBICR                    Allocated to registers ;size:1
;@EEPROM_Write_Read INDF2                     Allocated to registers ;size:1
;@EEPROM_Write_Read HBUF                      Allocated to registers ;size:1
;@EEPROM_Write_Read PDB                       Allocated to registers ;size:1
;@EEPROM_Write_Read INTCR0                    Allocated to registers ;size:1
;@EEPROM_Write_Read INTF0                     Allocated to registers ;size:1
;@EEPROM_Write_Read INTCR1                    Allocated to registers ;size:1
;@EEPROM_Write_Read INTF1                     Allocated to registers ;size:1
;@EEPROM_Write_Read IOA                       Allocated to registers ;size:1
;@EEPROM_Write_Read OEA                       Allocated to registers ;size:1
;@EEPROM_Write_Read PUA                       Allocated to registers ;size:1
;@EEPROM_Write_Read ANSA                      Allocated to registers ;size:1
;@EEPROM_Write_Read IOB                       Allocated to registers ;size:1
;@EEPROM_Write_Read OEB                       Allocated to registers ;size:1
;@EEPROM_Write_Read PUB                       Allocated to registers ;size:1
;@EEPROM_Write_Read ANSB                      Allocated to registers ;size:1
;@EEPROM_Write_Read IOC                       Allocated to registers ;size:1
;@EEPROM_Write_Read OEC                       Allocated to registers ;size:1
;@EEPROM_Write_Read PUC                       Allocated to registers ;size:1
;@EEPROM_Write_Read ANSC                      Allocated to registers ;size:1
;@EEPROM_Write_Read IOIDS                     Allocated to registers ;size:1
;@EEPROM_Write_Read I2CADR                    Allocated to registers ;size:1
;@EEPROM_Write_Read I2CCON                    Allocated to registers ;size:1
;@EEPROM_Write_Read I2CBUF                    Allocated to registers ;size:1
;@EEPROM_Write_Read PWM0CR                    Allocated to registers ;size:1
;@EEPROM_Write_Read PWM0D                     Allocated to registers ;size:1
;@EEPROM_Write_Read TXCR                      Allocated to registers ;size:1
;@EEPROM_Write_Read TXREG                     Allocated to registers ;size:1
;@EEPROM_Write_Read RXCR                      Allocated to registers ;size:1
;@EEPROM_Write_Read RXREG                     Allocated to registers ;size:1
;@EEPROM_Write_Read BRGDH                     Allocated to registers ;size:1
;@EEPROM_Write_Read BRGDL                     Allocated to registers ;size:1
;@EEPROM_Write_Read ADCON0                    Allocated to registers ;size:1
;@EEPROM_Write_Read ADCON1                    Allocated to registers ;size:1
;@EEPROM_Write_Read ADL                       Allocated to registers ;size:1
;@EEPROM_Write_Read ADH                       Allocated to registers ;size:1
;@EEPROM_Write_Read ADCON2                    Allocated to registers ;size:1
;@EEPROM_Write_Read T1CR                      Allocated to registers ;size:1
;@EEPROM_Write_Read TC1CL                     Allocated to registers ;size:1
;@EEPROM_Write_Read TC1CH                     Allocated to registers ;size:1
;@EEPROM_Write_Read T0CR                      Allocated to registers ;size:1
;@EEPROM_Write_Read TC0CL                     Allocated to registers ;size:1
;@EEPROM_Write_Read TC0CH                     Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1DEAD                  Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1S                     Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1CR                    Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1DL                    Allocated to registers ;size:1
;@EEPROM_Write_Read PWM1DH                    Allocated to registers ;size:1
;@EEPROM_Write_Read EECON1                    Allocated to registers ;size:1
;@EEPROM_Write_Read EECON2                    Allocated to registers ;size:1
;@EEPROM_Write_Read VREFCAL                   Allocated to registers ;size:1
;@EEPROM_Write_Read IRCCAL                    Allocated to registers ;size:1
;@end Allocation info for local variables in function 'EEPROM_Write_Read';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; code
;--------------------------------------------------------
code_EEPROM_WRITE_READ	code
;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_EEPROM_WRITE_READ__Interrupt_INIT	code
_Interrupt_INIT:	;Function start
; 2 exit points
;	.line	90; EEPROM_WRITE_READ.C	INTCR0 = 0;
	CLRR	_INTCR0
;	.line	91; EEPROM_WRITE_READ.C	INTF0 = 0;
	CLRR	_INTF0
;	.line	92; EEPROM_WRITE_READ.C	INTCR1 = 0;
	CLRR	_INTCR1
;	.line	93; EEPROM_WRITE_READ.C	INTF1 = 0;
	CLRR	_INTF1
;	.line	94; EEPROM_WRITE_READ.C	OPTION = 0;
	CLRR	_OPTION
	RETURN	
; exit point of _Interrupt_INIT

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_EEPROM_WRITE_READ__EEPROM_Read_Byte	code
_EEPROM_Read_Byte:	;Function start
; 2 exit points
;	.line	78; EEPROM_WRITE_READ.C	EEMOD = 1;                            //读EE，需置位
	BSET	_EECON1bits,7
;	.line	81; EEPROM_WRITE_READ.C	__endasm;
	;
	RDT
	
;	.line	82; EEPROM_WRITE_READ.C	EEMOD = 0;      	                  //写完EE，清除该位
	BCLR	_EECON1bits,7
	RETURN	
; exit point of _EEPROM_Read_Byte

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_EEPROM_WRITE_READ__EEPROM_Write_Byte	code
_EEPROM_Write_Byte:	;Function start
; 2 exit points
;	.line	61; EEPROM_WRITE_READ.C	__endasm;
	;
	MOVIA	0xAA
	
;	.line	63; EEPROM_WRITE_READ.C	EEMOD = 1;                            //读写EE/MTP时需置位
	BSET	_EECON1bits,7
;	.line	64; EEPROM_WRITE_READ.C	EEWEN = 1;                            //使能EE/MTP写入
	BSET	_EECON1bits,0
;	.line	65; EEPROM_WRITE_READ.C	EELOCK3 = 1;                          //EE/MTP写入解锁流程1
	BSET	_EECON2bits,3
;	.line	66; EEPROM_WRITE_READ.C	EELOCK2 = 1;                          //EE/MTP写入解锁流程2
	BSET	_EECON2bits,2
;	.line	67; EEPROM_WRITE_READ.C	EELOCK1 = 1;                          //EE/MTP写入解锁流程3
	BSET	_EECON2bits,1
;	.line	68; EEPROM_WRITE_READ.C	EEWE = 1;       	                  //写入
	BSET	_EECON2bits,0
;	.line	69; EEPROM_WRITE_READ.C	__NOP();                              //CPU暂停，等待EE写入结束
	NOP
;	.line	70; EEPROM_WRITE_READ.C	EEMOD = 0;      	                  //写完EE，清除该位
	BCLR	_EECON1bits,7
	RETURN	
; exit point of _EEPROM_Write_Byte

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;functions called:
;   _EEPROM_Read_Byte
;   _EEPROM_Read_Byte
;; Starting pCode block
S_EEPROM_WRITE_READ__EEPROM_Read	code
_EEPROM_Read:	;Function start
; 2 exit points
;	.line	38; EEPROM_WRITE_READ.C	FSR1 = 0x08;
	MOVIA	0x08
	MOVAR	_FSR1
;	.line	39; EEPROM_WRITE_READ.C	FSR0 = 0x00;
	CLRR	_FSR0
;	.line	40; EEPROM_WRITE_READ.C	for(FSR0 = 0;FSR0<255;FSR0++)         //循环读
	CLRR	_FSR0
_00119_DS_:
	MOVIA	0xff
	SUBRA	_FSR0,0
	JBTS0	STATUS,0
	GOTO	_00121_DS_
;	.line	42; EEPROM_WRITE_READ.C	EEPROM_Read_Byte();
	CALL	_EEPROM_Read_Byte
;	.line	46; EEPROM_WRITE_READ.C	__endasm;
	;
	JCMPAI	0xAA
	NOP
	
;	.line	47; EEPROM_WRITE_READ.C	if(EECON1 == 1)                   //校验00、55、AA、FF是否读写成功
	MOVR	_EECON1,0
	JCMPAI	0x01
	GOTO	_00120_DS_
;	.line	49; EEPROM_WRITE_READ.C	__NOP();                      //读失败 
	NOP
_00120_DS_:
;	.line	40; EEPROM_WRITE_READ.C	for(FSR0 = 0;FSR0<255;FSR0++)         //循环读
	INCR	_FSR0,1
	GOTO	_00119_DS_
_00121_DS_:
	RETURN	
; exit point of _EEPROM_Read

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;functions called:
;   _Interrupt_INIT
;   _EEPROM_Write_Byte
;   _EEPROM_Read
;   _Interrupt_INIT
;   _EEPROM_Write_Byte
;   _EEPROM_Read
;; Starting pCode block
S_EEPROM_WRITE_READ__EEPROM_Write_Read	code
_EEPROM_Write_Read:	;Function start
; 2 exit points
;	.line	18; EEPROM_WRITE_READ.C	Interrupt_INIT();                     //在读写EEPROM时需关闭所有中断
	CALL	_Interrupt_INIT
;	.line	19; EEPROM_WRITE_READ.C	FSR1 = 0x08;
	MOVIA	0x08
	MOVAR	_FSR1
;	.line	20; EEPROM_WRITE_READ.C	FSR0 = 0x00;
	CLRR	_FSR0
;	.line	21; EEPROM_WRITE_READ.C	for(FSR0 = 0;FSR0 < 255;FSR0++)       //循环写
	CLRR	_FSR0
_00109_DS_:
	MOVIA	0xff
	SUBRA	_FSR0,0
	JBTS0	STATUS,0
	GOTO	_00107_DS_
;	.line	23; EEPROM_WRITE_READ.C	EEPROM_Write_Byte();
	CALL	_EEPROM_Write_Byte
;	.line	24; EEPROM_WRITE_READ.C	if(EECON1 == 1)                    //判断写字节是否失败
	MOVR	_EECON1,0
	JCMPAI	0x01
	GOTO	_00110_DS_
;	.line	26; EEPROM_WRITE_READ.C	__NOP();                        //写失败
	NOP
_00110_DS_:
;	.line	21; EEPROM_WRITE_READ.C	for(FSR0 = 0;FSR0 < 255;FSR0++)       //循环写
	INCR	_FSR0,1
	GOTO	_00109_DS_
_00107_DS_:
;	.line	29; EEPROM_WRITE_READ.C	EEPROM_Read();
	CALL	_EEPROM_Read
	RETURN	
; exit point of _EEPROM_Write_Read


;	code size estimation:
;	   49+    0 =    49 instructions (   98 byte)

	end
