;*******************(C) COPYRIGHT 2019 GRAND-LOTUS *************************
;* Project Name       : QT8S736 WDT Demo
;* File Name          : QT8S736_WDT.ASM
;* Author             : GRAND LOTUS
;* Version            : V1.00
;* Date               : 2019/07/01

;***************************************************************************
;
;Option: 16M/16T, WDT-Enable-288ms, RS-IO, BOR 2.4V, 
;
;***************************************************************************
		    LIST 		P=QT8S736			
#INCLUDE	 	QT8S736.INC
		
;***************************************************************************
;=================================C O D E===================================
;***************************************************************************
	        ORG			0000H
	        GOTO		MAIN_PROGRAM
            ORG			0008H
		    GOTO		Interrupt
		
;***************************************************************************
;===============================中断处理程序================================
;====================注：没有使能的中断不要判断中断标志位===================
;***************************************************************************			
Interrupt:
            PUSH        ;//进栈、保存A、STATUS
;//中断处理程序	
		    NOP		
Interrupt_End:		
            POP         ;//出栈、恢复A、STATUS			
		    RETIE
			
;***************************************************************************
;==================================主函数===================================
;***************************************************************************
MAIN_PROGRAM: 
            CALL       	SYSTEM_INIT            ;//系统初始化
		    CALL       	Clr_RAM_00H_7FH        ;//清零RAM
MAIN_LOOP:
		    NOP
		    BSET	   	OSCM,4                 ;//进入休眠模式
		    COMR	   	IOA,1
		    NOP
		    NOP
		    NOP		 
		    GOTO	   	MAIN_LOOP
		 



;***************************************************************************
;=============================系统初始化====================================
;***************************************************************************
#INCLUDE	SYSTEM_INIT.INC


			END
;*********************************END OF FILE******************************  
